/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package fsl;
public class FileSystemModel extends AbstractTreeModel implements java.io.Serializable {
	private String root;
	FileFilter filter = new FileFilter();
	
	
	public FileSystemModel() {
		this( System.getProperty( "user.home" ) );
	}
	
	
	public FileSystemModel(String startPath) {
		root=startPath;
	}
	
	
	public Object getRoot() {
		return new java.io.File(root);
	}
	
	
	public Object getChild(Object parent, int index) {
	
		java.io.File directory=(java.io.File)parent;
		String[] children=directory.list(filter);
		java.util.Arrays.sort(children);
		return new java.io.File(directory,children[index]);
	}
	
	
	public int getChildCount(Object parent) {
		java.io.File fileSysEntity=(java.io.File)parent;
		if (fileSysEntity.isDirectory()) {
			String[] children=fileSysEntity.list(filter);
			return children.length;
		}
		else {
			return 0;
		}
	}
	
	
	public boolean isLeaf(Object node) {
		return ( ( (java.io.File)node ).isFile() && ( (java.io.File)node ).getName().endsWith(".ebuild") );
	}
	
	
	public void valueForPathChanged(javax.swing.tree.TreePath path, Object newValue) {}
	
	
	public int getIndexOfChild(Object parent,Object child) {
		java.io.File directory = (java.io.File)parent;
		java.io.File fileSysEntity = (java.io.File)child;
		String[] children = directory.list(filter);
		java.util.Arrays.sort(children);
		int result =-1;
		for (int i=0;i<children.length;i++) {
			if (fileSysEntity.getName().equals(children[i])) {
				result =i;
				break;
			}
		}
		return result;
	}
}