/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package fsl;
public class TreeModelSupport {
   private java.util.Vector vector = new java.util.Vector();
   
   
   public void addTreeModelListener( javax.swing.event.TreeModelListener listener ) {
      if ( listener != null && !vector.contains( listener ) ) {
         vector.addElement( listener );
      }
   }
   
   
   public void removeTreeModelListener( javax.swing.event.TreeModelListener listener ) {
      if ( listener != null ) {
         vector.removeElement( listener );
      }
   }
   
   
   public void fireTreeNodesChanged( javax.swing.event.TreeModelEvent e ) {
      java.util.Enumeration listeners = vector.elements();
      while ( listeners.hasMoreElements() ) {
         javax.swing.event.TreeModelListener listener = (javax.swing.event.TreeModelListener)listeners.nextElement();
         listener.treeNodesChanged( e );
      }
   }
   
   
   public void fireTreeNodesInserted( javax.swing.event.TreeModelEvent e ) {
      java.util.Enumeration listeners = vector.elements();
      while ( listeners.hasMoreElements() ) {
         javax.swing.event.TreeModelListener listener = (javax.swing.event.TreeModelListener)listeners.nextElement();
         listener.treeNodesInserted( e );
      }
   }
   
   
   public void fireTreeNodesRemoved( javax.swing.event.TreeModelEvent e ) {
      java.util.Enumeration listeners = vector.elements();
      while ( listeners.hasMoreElements() ) {
         javax.swing.event.TreeModelListener listener = (javax.swing.event.TreeModelListener)listeners.nextElement();
         listener.treeNodesRemoved( e );
      }
   }
   
   
   public void fireTreeStructureChanged( javax.swing.event.TreeModelEvent e ) {
      java.util.Enumeration listeners = vector.elements();
      while ( listeners.hasMoreElements() ) {
         javax.swing.event.TreeModelListener listener = (javax.swing.event.TreeModelListener)listeners.nextElement();
         listener.treeStructureChanged( e );
      }
   }
}