/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package gui.components;
public class CheckTextBox extends javax.swing.JPanel implements java.awt.event.MouseListener {
	private gui.frames.PortageMaster pm;
	private int FS;
	
	private javax.swing.JLabel label;
	private javax.swing.JCheckBox check;
	private java.net.URL pathUnselected;
	private java.net.URL pathSelected;
	private javax.swing.Icon unselectedIcon;
	private javax.swing.Icon selectedIcon;
	
	
	public CheckTextBox(gui.frames.PortageMaster owner, int newfontsize) {
		pm = owner;
		FS = newfontsize;
		initComponents();
	}
	
	
	public void setText(String s) {
		label.setText(s);
		
	}
	public String getText() {
		return label.getText();
	}
	
	
	public boolean isSelected() {
		return check.isSelected();
	}
	
	
	private void initComponents() {
		pathUnselected = this.getClass().getClassLoader().getResource("bludiamd.gif");
		pathSelected = this.getClass().getClassLoader().getResource("grnarrow.gif");
		unselectedIcon = new javax.swing.ImageIcon(pathUnselected);
		selectedIcon = new javax.swing.ImageIcon(pathSelected);
		label = new javax.swing.JLabel();
		label.setName("Label");
		label.addMouseListener(this);
		check = new javax.swing.JCheckBox();
		
		setLayout(new java.awt.BorderLayout());
		add(check,java.awt.BorderLayout.WEST);
		add(label,java.awt.BorderLayout.CENTER);
		
		
		check.setIcon(unselectedIcon);
		check.setSelectedIcon(selectedIcon);
		
		
		setBackground(new java.awt.Color(0,0,0));
		check.setBackground(new java.awt.Color(0,0,0));
		label.setForeground(new java.awt.Color(255,255,255));
		label.setFont(new java.awt.Font("Dialog",0,FS));
	}
	
	
	//
	//MouseListener interface implementation
	//
	public void mouseClicked(java.awt.event.MouseEvent e) {
	}
	
	
    	public void mousePressed(java.awt.event.MouseEvent e) {
		if (e.isPopupTrigger()) {
		    	try {
				if (e.getComponent().getName() == "Label") {
					logic.Helper helper = new logic.Helper();
					if (label.getText().endsWith(".ebuild")) {
						gui.menus.TreePopup x = new gui.menus.TreePopup(pm,"customdialog", "/usr/portage" + label.getText());
						x.show(e.getComponent(), e.getX(), e.getY());
					}
					else {
						gui.menus.TreePopup x = new gui.menus.TreePopup(pm,"customdialog", helper.getFullEbuildPath(label.getText()));
						x.show(e.getComponent(), e.getX(), e.getY());
					}
			    	}
		    	}
		    	catch (java.lang.NullPointerException exception) {
		    	}
	    	}
		else {
			if (e.getComponent().getName() == "Label") {
				if (check.isSelected()) {
					check.setSelected(false);
				}
				else {
					check.setSelected(true);
				}
			}
		}
	}
	
	
    	public void mouseReleased(java.awt.event.MouseEvent e) {
	}
	
	
	public void mouseEntered(java.awt.event.MouseEvent e) {
	}
	
	
	public void mouseExited(java.awt.event.MouseEvent e) {
	}
}
