/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package gui.components;
public class DisplayStatusPane extends javax.swing.JPanel {
	private javax.swing.JLabel[] labelTop, labelMiddle, labelButtom;
	private javax.swing.JPanel[] panelArray;
	private Index[] indexArray;
	private javax.swing.JLabel labelStatus;
	private javax.swing.JTabbedPane tabMain;
	private java.net.URL pathIcon;
	private javax.swing.Icon Icon;
	private String[][] last50;
	private int[] lastPosition;
	
	
	private int CurrentEmerges;
	private boolean RsyncStatus;
	
	
	public DisplayStatusPane() {
		initComponents();
	}
	
	
	public void setRsyncStatus(boolean newstatus) {
		RsyncStatus = newstatus;
	}
	public boolean getRsyncStatus() {
		return RsyncStatus;
	}
	
	
	public void setCurrentEmerges(int i) {
		CurrentEmerges = i;
	}
	public int getCurrentEmerges() {
		return CurrentEmerges;
	}
	
	
	private void initComponents() {
		tabMain = new javax.swing.JTabbedPane(javax.swing.JTabbedPane.TOP, javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
		panelArray = new javax.swing.JPanel[10];
		labelTop = new javax.swing.JLabel[10];
		labelMiddle = new javax.swing.JLabel[10];
		labelButtom = new javax.swing.JLabel[10];
		labelStatus = new javax.swing.JLabel(": )");
		labelStatus.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
		pathIcon = this.getClass().getClassLoader().getResource("bludiamd.gif");
		Icon = new javax.swing.ImageIcon(pathIcon);
		
		
		indexArray = new Index[10];
		for (int i=0;i<indexArray.length;i++) {
			indexArray[i] = new Index();
		}
		
		
		lastPosition = new int[10];
		last50 = new String[10][50];
		
		
		setLayout(new java.awt.BorderLayout());
		add(tabMain, java.awt.BorderLayout.CENTER);
		add(labelStatus,java.awt.BorderLayout.NORTH);
	}
	
	
	public int addStatusTab(String s) {
		int i = 0;
		
		
		while (!(indexArray[i].isFree())) {
			i = i + 1;
		}
		
		
		panelArray[i] = new javax.swing.JPanel();
		labelTop[i] = new javax.swing.JLabel();
		labelMiddle[i] = new javax.swing.JLabel();
		labelButtom[i] = new javax.swing.JLabel();
		
		
		indexArray[i].taken();
		panelArray[i].setLayout(new java.awt.GridLayout(0,1));
		panelArray[i].add(labelTop[i]);
		panelArray[i].add(labelMiddle[i]);
		panelArray[i].add(labelButtom[i]);
		lastPosition[i] = 0;
		
		
		tabMain.addTab(s,Icon,panelArray[i],s);
		return i;
	}
	
	
	public int addStatusTab(String s, java.lang.Process p) {
		int i = 0;
		
		
		while (!(indexArray[i].isFree())) {
			i = i + 1;
		}
		
		
		panelArray[i] = new javax.swing.JPanel();
		labelTop[i] = new javax.swing.JLabel();
		labelMiddle[i] = new javax.swing.JLabel();
		labelButtom[i] = new javax.swing.JLabel();
		
		
		indexArray[i].taken();
		//panelArray[i].addMouseListener(new ML(p));
		panelArray[i].setName(new Integer(i).toString());
		panelArray[i].setLayout(new java.awt.GridLayout(0,1));
		panelArray[i].add(labelTop[i]);
		panelArray[i].add(labelMiddle[i]);
		panelArray[i].add(labelButtom[i]);
		lastPosition[i] = 0;
		
		
		tabMain.addTab(s,Icon,panelArray[i],s);
		return i;
	}
	
	
	public String[] removeStatusTab(int index) {
		tabMain.remove(panelArray[index]);
		
		
		String[] result = new String[50];
		int j = 0;
		for (int i = lastPosition[index];i<50;i++) {
			result[j] = last50[index][i];
			last50[index][i] = null;
			j = j+1;
		}
		for (int i = 0;i < lastPosition[index];i++) {
			result[j] = last50[index][i];
			last50[index][i] = null;
			j = j + 1;
		}
		
		
		panelArray[index] = null;
		labelTop[index] = null;
		labelMiddle[index] = null;
		labelButtom[index] = null;
		
		
		indexArray[index].free();
		
		
		return result;
	}
	
	
	public void updateStatusTab(String s, int index) {
		if (lastPosition[index] == 50) {
			lastPosition[index] = 0;
		}
		last50[index][lastPosition[index]] = s;
		lastPosition[index] = lastPosition[index] + 1;
		
		
		labelTop[index].setText(labelMiddle[index].getText());
		labelMiddle[index].setText(labelButtom[index].getText());
		labelButtom[index].setText(s);
	}
	
	
	public void setStatus(String s) {
		labelStatus.setText(s);
	}
	
	
	//
	// Index class.
	//
	class Index {
		private boolean Free;
		
		
		public Index() {
			Free = true;
		}
		
		
		public boolean isFree() {
			return Free;
		}
		public void taken() {
			Free = false;
		}
		public void free() {
			Free = true;
		}
	}
	
	
	//
	// KillPopup class
	//
	class KillPopup extends javax.swing.JPopupMenu {
		private javax.swing.JMenuItem menuKill;
		private java.lang.Process P;
		
		
		public KillPopup(java.lang.Process p) {
			P = p;
			initComponents();
		}
		
		
		private void initComponents() {
			menuKill = new javax.swing.JMenuItem();
			menuKill.setText("Kill");
			menuKill.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent evt) {
					menuKill_Clicked();
				}
			});
			
			
			add(menuKill);
		}
		
		
		private void menuKill_Clicked() {
			System.out.println(P);
			P.destroy();
		}
	}
	
	
	//
	// MouseListener class implementation
	//
	class ML implements java.awt.event.MouseListener {
		private java.lang.Process P;
		
		
		public ML(java.lang.Process p) {
			P = p;
		}
		
		
		public void mouseClicked(java.awt.event.MouseEvent e) {
		}
		public void mousePressed(java.awt.event.MouseEvent e) {
			if (e.isPopupTrigger()) {
				KillPopup z = new KillPopup(P);
				//System.out.println(e.getComponent().getName());
				z.show(e.getComponent(), e.getX(), e.getY());
			}
		}
		public void mouseReleased(java.awt.event.MouseEvent e) {
		}
		public void mouseEntered(java.awt.event.MouseEvent e) {
		}
		public void mouseExited(java.awt.event.MouseEvent e) {
		}
	}
}
