/*
Copyright (C) 2002-2003 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



package gui.dialogs;
public class DialogCustomTable extends javax.swing.JDialog {
	
	
	private String Type;
	private gui.frames.PortageMaster pm;
	private String[] IncomingArray, ReturningArray;
	private gui.components.CheckTextBox[] CheckTextBoxArray;
	
	
	private javax.swing.JToolBar tbButtons;
	private javax.swing.JButton buttonEmerge, buttonRefresh, buttonClose;
	private javax.swing.ImageIcon iconEmerge, iconRefresh, iconClose;
	private javax.swing.JScrollPane scroller;
	private javax.swing.JPanel panel;
	private javax.swing.JCheckBox checkParallel;
	
	
	public DialogCustomTable(gui.frames.PortageMaster owner, String[] a, String type_of_dialog) {
		super(owner);
		pm = owner;
		Type = type_of_dialog;
		IncomingArray = a;
		if (a.length > 0)
			initComponents();
		else {
			Object[] options = {"OK"};
			int result = javax.swing.JOptionPane.showOptionDialog(null,"\nThere are no ebuilds that satisfy your request.\n\n",
			"Information",
			javax.swing.JOptionPane.OK_OPTION,
			javax.swing.JOptionPane.INFORMATION_MESSAGE,
			null,
			options,
			options[0]);
		}
	}
	
	
	private void initComponents() {
		panel = new javax.swing.JPanel();
		scroller = new javax.swing.JScrollPane();
		checkParallel = new javax.swing.JCheckBox("Parallel?");
		tbButtons = new javax.swing.JToolBar();
		iconEmerge = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Import16.gif"));
		iconRefresh = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Refresh16.gif"));
		iconClose = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Stop16.gif"));
		buttonEmerge = new javax.swing.JButton(new DCT_EmergeAction(this, pm, iconEmerge));
		buttonRefresh = new javax.swing.JButton(new DCT_RefreshAction(this, pm, iconRefresh));
		buttonClose = new javax.swing.JButton(new DCT_CloseAction(this, pm, iconClose));
		
		
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing( java.awt.event.WindowEvent e ) {
				hide();
			}
		});
		
		
		CheckTextBoxArray = new gui.components.CheckTextBox[IncomingArray.length];
		gui.components.CheckTextBox item;
		panel.setLayout(new java.awt.GridLayout(0,1));
		for (int i=0;i<IncomingArray.length;i++) {
			item = new gui.components.CheckTextBox(pm, pm.getGP().getFS());
			item.setText(IncomingArray[i]);
			CheckTextBoxArray[i]=item;
			panel.add(CheckTextBoxArray[i]);
		}
		
		
		panel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
		panel.setBackground(new java.awt.Color(0,0,0));
		
		
		scroller.add(panel);
		scroller.setPreferredSize(new java.awt.Dimension(650,350));
		scroller.setViewportView(panel);
		scroller.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(3, 3, 3, 3)));
		
		
		javax.swing.JToolBar tbUp = new javax.swing.JToolBar();
		javax.swing.JToolBar tbDown = new javax.swing.JToolBar();
		tbUp.add(checkParallel);
		tbUp.addSeparator();
		tbUp.add(buttonEmerge);
		tbUp.addSeparator();
		tbUp.add(buttonRefresh);
		tbDown.add(buttonClose);
		tbButtons.setLayout(new java.awt.BorderLayout());
		tbButtons.add(tbUp, java.awt.BorderLayout.NORTH);
		tbButtons.add(tbDown, java.awt.BorderLayout.SOUTH);
		tbUp.setRollover(true);
		tbUp.setOrientation(1);
		tbUp.setFloatable(false);
		tbDown.setRollover(true);
		tbDown.setOrientation(1);
		tbDown.setFloatable(false);
		tbButtons.setRollover(true);
		tbButtons.setOrientation(1);
		tbButtons.setFloatable(false);
		
		
		getContentPane().add(scroller,java.awt.BorderLayout.CENTER);
		getContentPane().add(tbButtons,java.awt.BorderLayout.EAST);
		setLocation(150,150);
		
		
		pack();
		if (Type=="system") {
			setTitle("update system");
		}
		else {
			if (Type=="world") {
				setTitle("update world");
			}
			else {
				if (Type=="find") {
					setTitle("find");
					buttonRefresh.setEnabled(false);
				}
			}
		}
		buttonClose.requestFocus();
		show();
	}
	
	
	public String[] getSelectedOnes() {
		logic.Helper h = new logic.Helper();
		return h.sortSelected(CheckTextBoxArray);
	}
	
	
	public boolean getParallel() {
		return checkParallel.isSelected();
	}
	
	
	public String getType() {
		return Type;
	}
}


//
// Custom emerge action class. Its bound to buttonEmerge and might be used for key bindings
// as well.
//
class DCT_EmergeAction extends javax.swing.AbstractAction {
	private DialogCustomTable DCT;
	private gui.frames.PortageMaster pm;
	
	
	public DCT_EmergeAction(DialogCustomTable dct, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Emerge", icon);
		DCT = dct;
		pm = p;
	}
	public void actionPerformed(java.awt.event.ActionEvent e) {
		String[] selectedOnes;
		selectedOnes = DCT.getSelectedOnes();
		if (selectedOnes.length==0) {
			DCT.hide();
		}
		else {
			if (DCT.getParallel()) {
				for (int i = 0; i < selectedOnes.length; i++) {
					logic.Ebuild z = new logic.Ebuild(pm);
					z.setSingleEbuildPath(selectedOnes[i]);
					z.doEmerge();
				}
			}
			else {
				logic.Ebuild z = new logic.Ebuild(pm);
				z.setEbuildPaths(selectedOnes);
				z.doEmerge();
			}
		}
	}
}


//
// Custom refresh action, bound to buttonRefresh
//
class DCT_RefreshAction extends javax.swing.AbstractAction {
	private DialogCustomTable DCT;
	private gui.frames.PortageMaster pm;
	
	
	public DCT_RefreshAction(DialogCustomTable dct, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Refresh", icon);
		DCT = dct;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		DCT.hide();
		logic.Ebuild z = new logic.Ebuild(pm);
		if (DCT.getType().equals("system")) {
			z.updateSystem();
		}
		else {
			if (DCT.getType().equals("world")) {
				z.updateWorld();
			}
		}
	}
}


//
// Custom close action bound to buttonClose.
//
class DCT_CloseAction extends javax.swing.AbstractAction {
	private DialogCustomTable DCT;
	private gui.frames.PortageMaster pm;
	
	
	public DCT_CloseAction(DialogCustomTable dct, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Close", icon);
		DCT = dct;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		DCT.hide();
	}
}
