package gui.dialogs;
public class DialogEbuildProperties extends javax.swing.JDialog {
	private gui.frames.PortageMaster pm;
	private logic.Ebuild ebuild;
	private String Type;
	
	
	private javax.swing.JButton buttonEmerge, buttonBrowse, buttonUnmerge, buttonChangeLog, buttonEdit, buttonClose;
	private javax.swing.ImageIcon iconEmerge = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Import16.gif"));
	private javax.swing.ImageIcon iconUnmerge = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Export16.gif"));
	private javax.swing.ImageIcon iconBrowse = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Home16.gif"));
	private javax.swing.ImageIcon iconChangeLog = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("About16.gif"));
	private javax.swing.ImageIcon iconEdit = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Edit16.gif"));
	private javax.swing.ImageIcon iconClose = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Stop16.gif"));
	private javax.swing.JScrollPane scrollInfo;
	private javax.swing.JPanel panelInfo;
	private javax.swing.JTextArea textInfo;
	private javax.swing.JToolBar tbButtons;
	
	
	public DialogEbuildProperties(gui.frames.PortageMaster owner, String path,String t) {
		super(owner);
		pm = owner;
		Type = t;
		ebuild = new logic.Ebuild(pm);
		ebuild.setSingleEbuildPath(path);
		ebuild.readEbuildProperties();
		
		
		initComponents();
	}
	
	
	private void initComponents() {
		setTitle("About");
		tbButtons = new javax.swing.JToolBar();
		scrollInfo = new javax.swing.JScrollPane();
		panelInfo = new javax.swing.JPanel();
		
		
		textInfo = new javax.swing.JTextArea();
		buttonClose = new javax.swing.JButton(new DEP_CloseAction(this, pm, iconClose));
		buttonEmerge = new javax.swing.JButton(new DEP_EmergeAction(this, pm, iconEmerge));
		buttonUnmerge = new javax.swing.JButton(new DEP_UnmergeAction(this, pm, iconUnmerge));
		buttonChangeLog = new javax.swing.JButton(new DEP_ChangeLogAction(this, pm, iconChangeLog));
		buttonEdit = new javax.swing.JButton(new DEP_EditAction(this, pm, iconEdit));
		buttonBrowse = new javax.swing.JButton(new DEP_BrowseAction(this, pm, iconBrowse));
		
		
		textInfo.setEditable(false);
		textInfo.setBackground(new java.awt.Color(0,0,0));
		textInfo.setForeground(new java.awt.Color(255,255,255));
		textInfo.setFont(new java.awt.Font("Dialog", 0, pm.getGP().getFS()));
		textInfo.setLineWrap(true);
		//textInfo.append("\n");
		textInfo.append("Description: " + ebuild.getDescription() + "\n");
		textInfo.append("Homepage: " + ebuild.getHomePage() + "\n");
		textInfo.append("License: " + ebuild.getLicense() + "\n");
		
		
		scrollInfo.add(textInfo);
		scrollInfo.setViewportView(textInfo);
		scrollInfo.setBackground(new java.awt.Color(0,0,0));
		scrollInfo.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
		scrollInfo.setPreferredSize(new java.awt.Dimension(500, 350));
		
		
		panelInfo.add(scrollInfo);
		//panelInfo.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(3, 3, 3, 3)));
		
		
		javax.swing.JToolBar tbUp = new javax.swing.JToolBar();
		javax.swing.JToolBar tbDown = new javax.swing.JToolBar();
		tbUp.add(buttonEmerge);
		tbUp.addSeparator();
		tbUp.add(buttonUnmerge);
		tbUp.addSeparator();
		tbUp.add(buttonBrowse);
		tbUp.addSeparator();
		tbUp.add(buttonChangeLog);
		tbUp.addSeparator();
		tbUp.add(buttonEdit);
		tbDown.add(buttonClose);
		tbButtons.setLayout(new java.awt.BorderLayout());
		tbButtons.add(tbUp, java.awt.BorderLayout.NORTH);
		tbButtons.add(tbDown, java.awt.BorderLayout.SOUTH);
		tbUp.setRollover(true);
		tbUp.setOrientation(1);
		tbUp.setFloatable(false);
		tbDown.setRollover(true);
		tbDown.setOrientation(1);
		tbDown.setFloatable(false);
		tbButtons.setRollover(true);
		tbButtons.setOrientation(1);
		tbButtons.setFloatable(false);
		
		
		getContentPane().add(tbButtons, java.awt.BorderLayout.EAST);
		getContentPane().add(panelInfo, java.awt.BorderLayout.CENTER);
		//getContentPane().add(panelButtons, java.awt.BorderLayout.SOUTH);
		
		
		if (Type == "installed") {
			buttonEmerge.setEnabled(false);
			buttonChangeLog.setEnabled(false);
		}
		else {
			if ((Type == "all") || (Type == "customdialog") || (Type == "local")) {
				buttonUnmerge.setEnabled(false);
			}
		}
		
		
		setLocation(150,150);
		pack();
		show();
	}
	
	
	public logic.Ebuild getEbuild() {
		return ebuild;
	}
}


//
// Custom close action bound to buttonClose.
//
class DEP_CloseAction extends javax.swing.AbstractAction {
	private DialogEbuildProperties DEP;
	private gui.frames.PortageMaster pm;
	
	
	public DEP_CloseAction(DialogEbuildProperties dep, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Close", icon);
		DEP = dep;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		DEP.hide();
	}
}


//
// Custom emerge action
//
class DEP_EmergeAction extends javax.swing.AbstractAction {
	private DialogEbuildProperties DEP;
	private gui.frames.PortageMaster pm;
	
	
	public DEP_EmergeAction(DialogEbuildProperties dep, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Emerge", icon);
		DEP = dep;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		DEP.getEbuild().doEmerge();
	}
}


//
// Custom unmerge action
class DEP_UnmergeAction extends javax.swing.AbstractAction {
	private DialogEbuildProperties DEP;
	private gui.frames.PortageMaster pm;
	
	
	public DEP_UnmergeAction(DialogEbuildProperties dep, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Unmerge", icon);
		DEP = dep;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		pm.unmergeRequested();
	}
}


//
// Custom browse action
//
class DEP_BrowseAction extends javax.swing.AbstractAction {
	private DialogEbuildProperties DEP;
	private gui.frames.PortageMaster pm;
	
	
	public DEP_BrowseAction(DialogEbuildProperties dep, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Browse", icon);
		DEP = dep;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		DEP.getEbuild().browse();
	}
}


//
// Custom viewchangelog action
//
class DEP_ChangeLogAction extends javax.swing.AbstractAction {
	private DialogEbuildProperties DEP;
	private gui.frames.PortageMaster pm;
	
	
	public DEP_ChangeLogAction(DialogEbuildProperties dep, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("ChangeLog", icon);
		DEP = dep;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		DEP.getEbuild().viewChangeLog();
	}
}


//
// Custom edit action
//
class DEP_EditAction extends javax.swing.AbstractAction {
	private DialogEbuildProperties DEP;
	private gui.frames.PortageMaster pm;
	
	
	public DEP_EditAction(DialogEbuildProperties dep, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Edit", icon);
		DEP = dep;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		DEP.getEbuild().edit();
	}
}
