/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package gui.dialogs;
public class DialogEmergeResult extends javax.swing.JDialog {
	gui.frames.PortageMaster pm;
	
	private javax.swing.ImageIcon iconClose = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Stop16.gif"));
	private javax.swing.JButton buttonClose;
	private javax.swing.JToolBar tbButtons;
	private javax.swing.JScrollPane panelText;
	private javax.swing.JTextArea textArea;
	
	
	public DialogEmergeResult(gui.frames.PortageMaster owner, String title, String a[]) {
		super(owner);
		pm = owner;
		setTitle(title);
		
		
		tbButtons = new javax.swing.JToolBar();
		buttonClose = new javax.swing.JButton(new DER_CloseAction(this, pm, iconClose));
		panelText = new javax.swing.JScrollPane();
		textArea = new javax.swing.JTextArea();
		
		
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing( java.awt.event.WindowEvent e ) {
				hide();
			}
		});
		
		
		for (int i = 0;i< a.length;i++) {
			if (a[i]!=null) {
				textArea.append(a[i] + "\n");
			}
		}
		
		
		textArea.setBackground(new java.awt.Color(0,0,0));
		textArea.setForeground(new java.awt.Color(255,255,255));
		textArea.setFont(new java.awt.Font("Dialog", 0, pm.getGP().getFS()));
		panelText.add(textArea);
		panelText.setViewportView(textArea);
		panelText.setPreferredSize(new java.awt.Dimension(650,350));
		panelText.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(3, 3, 3, 3)));
		
		
		javax.swing.JToolBar tbUp = new javax.swing.JToolBar();
		javax.swing.JToolBar tbDown = new javax.swing.JToolBar();
		tbDown.add(buttonClose);
		tbButtons.setLayout(new java.awt.BorderLayout());
		tbButtons.add(tbDown, java.awt.BorderLayout.SOUTH);
		tbUp.setRollover(true);
		tbUp.setOrientation(1);
		tbUp.setFloatable(false);
		tbDown.setRollover(true);
		tbDown.setOrientation(1);
		tbDown.setFloatable(false);
		tbButtons.setRollover(true);
		tbButtons.setOrientation(1);
		tbButtons.setFloatable(false);
		
		
		getContentPane().setLayout(new java.awt.BorderLayout());
		getContentPane().add(panelText, java.awt.BorderLayout.CENTER);
		getContentPane().add(tbButtons, java.awt.BorderLayout.EAST);
		
		
		setLocation(200,200);
		
		
		pack();
		buttonClose.requestFocus();
		show();
	}
	
	
	private void button_OK_Clicked() {
		hide();
	}
}


//
// Custom close action
//
class DER_CloseAction extends javax.swing.AbstractAction {
	private DialogEmergeResult DER;
	private gui.frames.PortageMaster pm;
	
	
	public DER_CloseAction(DialogEmergeResult der, gui.frames.PortageMaster p, javax.swing.ImageIcon icon) {
		super("Close", icon);
		DER = der;
		pm = p;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		DER.hide();
	}
}
