/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package gui.dialogs;
public class DialogFind extends javax.swing.JDialog {
	private String selection;
	private logic.Ebuild z;
	private gui.frames.PortageMaster Owner;
	
	
	public String getSelection() {
		return selection;
	}
	
	
	private javax.swing.JTextField textField;
	private javax.swing.JLabel label;
	private javax.swing.JButton buttonFind, buttonCancel;
	private javax.swing.JPanel panelButtons;
	private DF_FindAction actionFind;
	
	
	public DialogFind(gui.frames.PortageMaster owner) {
		super(owner);
		Owner = owner;
		
		
		actionFind = new DF_FindAction(this);
		
		
		label = new javax.swing.JLabel(" Searh for:");
		label.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
		getContentPane().add(label, java.awt.BorderLayout.NORTH);
		
		
		textField = new javax.swing.JTextField();
		textField.setAction(actionFind);
		textField.setPreferredSize(new java.awt.Dimension(200,20));
		getContentPane().add(textField, java.awt.BorderLayout.CENTER);
		
		
		buttonFind = new javax.swing.JButton(actionFind);
		buttonFind.setText("Find");
		
		
		buttonCancel = new javax.swing.JButton("Cancel");
		buttonCancel.addActionListener(
		new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e){
				button_Cancel_Clicked();
			}
		});
		
		
		panelButtons = new javax.swing.JPanel();
		panelButtons.setLayout(new java.awt.FlowLayout());
		panelButtons.add(buttonFind);
		panelButtons.add(buttonCancel);
		panelButtons.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
		getContentPane().add(panelButtons,java.awt.BorderLayout.SOUTH);
		setBounds(150,150,200,20);
		pack();
		show();
	}
	
	
	private void button_Cancel_Clicked() {
		hide();
	}
	
	
	public String getText() {
		return textField.getText();
	}
	
	
	public gui.frames.PortageMaster getPM() {
		return Owner;
	}
}


class DF_FindAction extends javax.swing.AbstractAction {
	private DialogFind DF;
	
	
	public DF_FindAction(DialogFind df) {
		DF = df;
	}
	
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		logic.Ebuild z = new logic.Ebuild(DF.getPM());
		if (!(DF.getText().length()<=1)) {
			z.setSearchString(DF.getText());
			z.find();
		}
		
		
		DF.hide();
	}
}
