/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package gui.menus;
public class MainMenu extends javax.swing.JMenuBar {
	private gui.frames.PortageMaster pm;
	
	
	private javax.swing.JMenuBar jMenuBar1;
	private javax.swing.JMenu menuFile, menuOptions, menuCommands, 
	menuHelp;
	private javax.swing.JMenuItem menuFile_makeconf, menuFile_makedefaults, menuFile_mask,
	menuFile_Exit, menuFile_localebuilds, menuCommands_Rsync, menuHelp_About,
	menuCommands_Find, menuCommands_Refresh, menuCommands_UpdateWorld, 
	menuCommands_UpdateSystem, menuOptions_Settings;
	private javax.swing.JRadioButtonMenuItem menuOptions_FS_Small, menuOptions_FS_Large;
	
	
	//
	//Constructor
	//
	public MainMenu (gui.frames.PortageMaster x){
		pm = x;
		initComponents();
	}
	
	
	//
	//initialise all components, menus in this case,
	//and associate them with coresponding events,actions
	//
	private void initComponents() {
		menuFile = new javax.swing.JMenu();
		menuFile_makeconf = new javax.swing.JMenuItem();
		menuFile_makedefaults = new javax.swing.JMenuItem();
		menuFile_mask = new javax.swing.JMenuItem();
		menuCommands = new javax.swing.JMenu();
		menuCommands_Find = new javax.swing.JMenuItem();
		menuCommands_Refresh = new javax.swing.JMenuItem();
		menuCommands_Rsync = new javax.swing.JMenuItem();
		menuCommands_UpdateSystem = new javax.swing.JMenuItem();
		menuCommands_UpdateWorld = new javax.swing.JMenuItem();
		menuFile_Exit = new javax.swing.JMenuItem();
		menuOptions = new javax.swing.JMenu();
		menuOptions_Settings = new javax.swing.JMenuItem();
		menuHelp = new javax.swing.JMenu();
		menuHelp_About = new javax.swing.JMenuItem();
		
		
		menuFile.setText("File");
		menuFile.setMnemonic(70);
		
		menuFile_makeconf.setText("make.conf");
		menuFile_makeconf.setToolTipText("edit /etc/make.conf");
		menuFile_makeconf.setPreferredSize(new java.awt.Dimension(100,19));
		menuFile_makeconf.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuFile_makeconf_Clicked(evt);
		    }
		});
		menuFile.add(menuFile_makeconf);
		
		
		menuFile_makedefaults.setText("make.defaults");
		menuFile_makedefaults.setToolTipText("view /etc/make.profile/make.defaults");
		menuFile_makedefaults.setPreferredSize(new java.awt.Dimension(100,19));
		menuFile_makedefaults.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuFile_makedefaults_Clicked(evt);
		    }
		});
		menuFile.add(menuFile_makedefaults);
		
		
		menuFile_mask.setText("package.mask");
		menuFile_mask.setToolTipText("edit /usr/portage/profiles/package.mask");
		menuFile_mask.setPreferredSize(new java.awt.Dimension(100,19));
		menuFile_mask.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuFile_mask_Clicked(evt);
		    }
		});
		menuFile.add(menuFile_mask);
		
		
		menuFile.addSeparator();
		
		
		menuFile_Exit.setText("Exit");
		menuFile_Exit.setToolTipText("bye");
		menuFile_Exit.setPreferredSize(new java.awt.Dimension(100,19));
		menuFile_Exit.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuFile_Exit_Clicked(evt);
		    }
		});
		menuFile.add(menuFile_Exit);
		
		
		add(menuFile);
		
		
		menuCommands.setText("Commands");
		menuCommands.setMnemonic(67);
		
		
		menuCommands_Refresh.setText("Refresh");
		menuCommands_Refresh.setToolTipText("refresh current view");
		menuCommands_Refresh.setPreferredSize(new java.awt.Dimension(100,19));
		menuCommands_Refresh.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuCommands_Refresh_Clicked(evt);
		    }
		});
		menuCommands.add(menuCommands_Refresh);
		
		
		menuCommands_Find.setText("Find");
		menuCommands_Find.setToolTipText("keyword search");
		menuCommands_Find.setPreferredSize(new java.awt.Dimension(100,19));
		menuCommands_Find.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuCommands_Find_Clicked(evt);
		    }
		});
		menuCommands.add(menuCommands_Find);
		
		
		menuCommands.addSeparator();
		
		
		menuCommands_Rsync.setText("Rsync");
		menuCommands_Rsync.setToolTipText("download newest ebuilds");
		menuCommands_Rsync.setPreferredSize(new java.awt.Dimension(100,19));
		menuCommands_Rsync.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuCommands_Rsync_Clicked(evt);
		    }
		});
		menuCommands.add(menuCommands_Rsync);
		
		
		menuCommands.addSeparator();
		
		
		menuCommands_UpdateSystem.setText("UpdateSystem");
		menuCommands_UpdateSystem.setToolTipText("check for most recent 'System' packages upgrades");
		menuCommands_UpdateSystem.setPreferredSize(new java.awt.Dimension(100,19));
		menuCommands_UpdateSystem.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuCommands_UpdateSystem_Clicked(evt);
		    }
		});
		menuCommands.add(menuCommands_UpdateSystem);
		
		
		menuCommands_UpdateWorld.setText("UpdateWorld");
		menuCommands_UpdateWorld.setToolTipText("check for most recent 'World' packages upgrades");
		menuCommands_UpdateWorld.setPreferredSize(new java.awt.Dimension(100,19));
		menuCommands_UpdateWorld.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuCommands_UpdateWorld_Clicked(evt);
		    }
		});
		menuCommands.add(menuCommands_UpdateWorld);
		
		
		add(menuCommands);
		
		
		menuOptions.setText("Options");
		menuOptions.setMnemonic(79);
		
		
		menuOptions_Settings.setText("Settings...");
		menuOptions_Settings.setPreferredSize(new java.awt.Dimension(100,19));
		menuOptions_Settings.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuOptions_Settings_Clicked(evt);
		    }
		});
		
		
		menuOptions.add(menuOptions_Settings);
		
		
		add(menuOptions);
		
		
		menuHelp.setText("Help");
		menuHelp.setMnemonic(72);
		menuHelp_About.setText("About");
		menuHelp_About.setPreferredSize(new java.awt.Dimension(100,19));
		menuHelp_About.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
			menuHelp_About_Clicked(evt);
		    }
		});
		
		
		menuHelp.add(menuHelp_About);
		add(menuHelp);
	}
	
	
	//
	//menu actions
	//
	private void menuOptions_Settings_Clicked(java.awt.event.ActionEvent evt) {
		new gui.dialogs.DialogSettings(pm);
	}
	
	
	private void menuHelp_About_Clicked(java.awt.event.ActionEvent evt) {
		
		Object[] options = {"OK"};
		int n = javax.swing.JOptionPane.showOptionDialog(null, 
		"Copyright (C) 2002-2003 Milos Negovanovic <milosn@xtra.co.nz>\n\n"

		+ "This program is free software; you can redistribute it and/or\n"
		+ "modify it under the terms of the GNU General Public License\n"
		+ "as published by the Free Software Foundation; either version 2\n"
		+ "of the License, or (at your option) any later version.\n\n"
		
		+ "This program is distributed in the hope that it will be useful,\n"
		+ "but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
		+ "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
		+ "GNU General Public License for more details.\n\n"
		
		+ "You should have received a copy of the GNU General Public License\n"
		+ "along with this program; if not, write to the Free Software\n"
		+ "Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.\n\n",
		"portageMaster",
		javax.swing.JOptionPane.OK_OPTION,
		javax.swing.JOptionPane.INFORMATION_MESSAGE,
		null,
		options,
		options[0]);
	}
	
	
	private void menuFile_makeconf_Clicked(java.awt.event.ActionEvent evt) {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.setEditString("/etc/make.conf");
		x.edit();
	}
	
	
	private void menuFile_makedefaults_Clicked(java.awt.event.ActionEvent evt) {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.setEditString("/etc/make.profile/make.defaults");
		x.edit();
	}
	
	
	private void menuFile_mask_Clicked(java.awt.event.ActionEvent evt) {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.setEditString("/usr/portage/profiles/package.mask");
		x.edit();
	}
	
	
	private void menuFile_Exit_Clicked(java.awt.event.ActionEvent evt) {
		System.exit(0);
	}
	
	
	private void menuCommands_Rsync_Clicked(java.awt.event.ActionEvent evt) {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.rsync();
	}
	
	
	private void menuCommands_Find_Clicked(java.awt.event.ActionEvent evt) {
		gui.dialogs.DialogFind z = new gui.dialogs.DialogFind(pm);
	}
	
	
	private void menuCommands_Refresh_Clicked(java.awt.event.ActionEvent evt) {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.refresh();
	}
	
	
	private void menuCommands_UpdateSystem_Clicked(java.awt.event.ActionEvent evt) {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.updateSystem();
	}
	
	
	private void menuCommands_UpdateWorld_Clicked(java.awt.event.ActionEvent evt) {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.updateWorld();
	}
}
