/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package gui.menus;
public class TreePopup extends javax.swing.JPopupMenu {
	private javax.swing.JMenuItem menuEdit, menuEmerge, menuUnmerge, menuAbout, menuChangeLog, menuDeps;
	private gui.frames.PortageMaster pm;
	private String Type;
	private String EbuildPath;
	
	
	public TreePopup(gui.frames.PortageMaster p, String t, String path) {
		Type = t;
		pm = p;
		EbuildPath = path;
		initComponents();
	}
	
	
	private void initComponents() {
		menuEmerge = new javax.swing.JMenuItem();
		menuEmerge.setText("Emerge");
		menuEmerge.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				menuEmerge_Clicked();
			}
		});
		add(menuEmerge);
		
		
		menuUnmerge = new javax.swing.JMenuItem();
		menuUnmerge.setText("Unmerge");
		menuUnmerge.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				menuUnmerge_Clicked();
			}
		});
		add(menuUnmerge);
		
		
		addSeparator();
		
		
		menuEdit = new javax.swing.JMenuItem();
		menuEdit.setText("Edit");
		menuEdit.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				menuEdit_Clicked();
			}
		});
		add(menuEdit);
		
		
		menuChangeLog = new javax.swing.JMenuItem();
		menuChangeLog.setText("ChangeLog");
		menuChangeLog.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				menuChangeLog_Clicked();
			}
		});
		add(menuChangeLog);
		
		
		menuDeps = new javax.swing.JMenuItem();
		menuDeps.setText("Deps");
		menuDeps.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				menuDeps_Clicked();
			}
		});
		add(menuDeps);
		
		
		menuAbout = new javax.swing.JMenuItem();
		menuAbout.setText("About");
		menuAbout.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				menuAbout_Clicked();
			}
		});
		add(menuAbout);
		
		
		if (Type == "installed") {
			menuEmerge.setEnabled(false);
			menuChangeLog.setEnabled(false);
		}
		else if (Type == "installed-simple") {
			menuEmerge.setEnabled(false);
			menuChangeLog.setEnabled(false);
			menuAbout.setEnabled(false);
			menuEdit.setEnabled(false);
			menuDeps.setEnabled(false);
		}
		else if ((Type == "all") || (Type == "customdialog") || (Type == "local")) {
			menuUnmerge.setEnabled(false);
			menuDeps.setEnabled(false);
		}
		else if ((Type == "all-simple") || (Type == "local-simple")){
			menuChangeLog.setEnabled(false);
			menuAbout.setEnabled(false);
			menuEdit.setEnabled(false);
			menuUnmerge.setEnabled(false);
			menuDeps.setEnabled(false);
		}
	}
	
	
	private void menuEdit_Clicked() {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.setEditString(EbuildPath);
		x.edit();
	}
	
	
	private void menuChangeLog_Clicked() {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.setSingleEbuildPath(EbuildPath);
		x.readEbuildProperties();
		x.viewChangeLog();
	}
	
	
	private void menuEmerge_Clicked() {
		if ((Type == "all") || (Type == "all-simple")) {
			pm.emergeRequested("all");
		}
		else if ((Type == "local") || (Type == "local-simple")) {
			pm.emergeRequested("local");
		}
		else if (Type == "customdialog") {
			logic.Ebuild x = new logic.Ebuild(pm);
			x.setSingleEbuildPath(EbuildPath);
			x.doEmerge();
		}
	}
	
	
	private void menuUnmerge_Clicked() {
		pm.unmergeRequested();
	}
	
	
	private void menuAbout_Clicked() {
		gui.dialogs.DialogEbuildProperties x = new gui.dialogs.DialogEbuildProperties(pm, EbuildPath, Type);
	}
	
	
	private void menuDeps_Clicked() {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.setSingleEbuildPath(EbuildPath);
		x.queryDeps();
	}
}
