/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package gui.splash;
public class Splash extends javax.swing.JWindow
{
    public Splash(int waittime) {
        javax.swing.JLabel picture = new javax.swing.JLabel(new javax.swing.ImageIcon(getClass().getClassLoader().getResource("icon-cow.png")));
	
	
	getContentPane().add(picture, java.awt.BorderLayout.CENTER);
	pack();
        
	
	java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension labelSize = picture.getPreferredSize();
        setLocation(screenSize.width/2 - (labelSize.width/2), screenSize.height/2 - (labelSize.height/2));
	
	
	addMouseListener(new java.awt.event.MouseAdapter() {
		public void mousePressed(java.awt.event.MouseEvent e) {
			setVisible(false);
			dispose();
                }
	});
        
	
	final int pause=waittime;
	
	
	final Runnable closerRunner = new Runnable() {
		public void run() {
			setVisible(false);
			dispose();
		}
	};
	
	
	final Runnable waitRunner = new Runnable() {
		public void run() {
			try {
				Thread.sleep(pause);
				javax.swing.SwingUtilities.invokeAndWait(closerRunner);
			}
			catch (Exception e) {
			}
		}
	};
	
	
	setVisible(true);
	Thread splashThread = new Thread(waitRunner, "SplashThread");
        splashThread.start();
    }
}
