package gui.toolbars;
public class MainToolBar extends javax.swing.JToolBar {
	private gui.frames.PortageMaster pm;
	private javax.swing.JButton buttonRsync, buttonUpdateSystem, buttonUpdateWorld, buttonFind, buttonRefresh, buttonEmerge;
	private javax.swing.ImageIcon iconRsync = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Undo16.gif"));
	private javax.swing.ImageIcon iconEmerge = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Import16.gif"));
	private javax.swing.ImageIcon iconUnmerge = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Export16.gif"));
	private javax.swing.ImageIcon iconUpdateSystem = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Host16.gif"));
	private javax.swing.ImageIcon iconUpdateWorld = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("WebComponent16.gif"));
	private javax.swing.ImageIcon iconFind = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Find16.gif"));
	private javax.swing.ImageIcon iconRefresh = new javax.swing.ImageIcon(getClass().getClassLoader().getResource("Refresh16.gif"));
	private javax.swing.JTextField textEmerge;
	private MTB_EmergeAction actionEmerge;
	
	
	public MainToolBar(gui.frames.PortageMaster owner) {
		pm = owner;
		initComponents();
	}
	
	
	private void initComponents() {
		buttonRsync = new javax.swing.JButton(iconRsync);
		buttonRsync.setToolTipText("rsync");
		buttonUpdateSystem = new javax.swing.JButton(iconUpdateSystem);
		buttonUpdateSystem.setToolTipText("update system");
		buttonUpdateWorld = new javax.swing.JButton(iconUpdateWorld);
		buttonUpdateWorld.setToolTipText("update world");
		buttonFind = new javax.swing.JButton(iconFind);
		buttonFind.setToolTipText("find");
		buttonRefresh = new javax.swing.JButton(iconRefresh);
		buttonRefresh.setToolTipText("refresh");
		actionEmerge = new MTB_EmergeAction(this);
		buttonEmerge = new javax.swing.JButton(actionEmerge);
		buttonEmerge.setText("Emerge");
		textEmerge = new javax.swing.JTextField();
		textEmerge.setAction(actionEmerge);
		
		
		buttonRsync.addActionListener(
		new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e){
				buttonRsync_Clicked();
			}
		});
		
		
		buttonUpdateSystem.addActionListener(
		new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e){
				buttonUpdateSystem_Clicked();
			}
		});
		
		
		buttonUpdateWorld.addActionListener(
		new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e){
				buttonUpdateWorld_Clicked();
			}
		});
		
		
		buttonFind.addActionListener(
		new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e){
				buttonFind_Clicked();
			}
		});
		
		
		buttonRefresh.addActionListener(
		new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e){
				buttonRefresh_Clicked();
			}
		});
		
		
		add(buttonRsync);
		addSeparator();
		add(buttonUpdateSystem);
		add(buttonUpdateWorld);
		addSeparator();
		add(buttonFind);
		add(buttonRefresh);
		addSeparator();
		addSeparator();
		add(buttonEmerge);
		add(textEmerge);
		
		
		setFloatable(false);
		setRollover(true);
	}
	
	
	private void buttonRsync_Clicked() {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.rsync();
	}
	
	
	private void buttonFind_Clicked() {
		gui.dialogs.DialogFind z = new gui.dialogs.DialogFind(pm);
	}
	
	
	private void buttonRefresh_Clicked() {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.refresh();
	}
	
	
	private void buttonUpdateSystem_Clicked() {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.updateSystem();
	}
	
	
	private void buttonUpdateWorld_Clicked() {
		logic.Ebuild x = new logic.Ebuild(pm);
		x.updateWorld();
	}
	
	
	private void buttonUnmerge_Clicked() {
	}
	
	
	public String getText() {
		return textEmerge.getText();
	}
	
	
	public gui.frames.PortageMaster getPM() {
		return pm;
	}
}


class MTB_EmergeAction extends javax.swing.AbstractAction {
	private MainToolBar MTB;
	public MTB_EmergeAction(MainToolBar mtb) {
		MTB = mtb;
	}
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		if (MTB.getText().length() > 0) {
			logic.Ebuild x = new logic.Ebuild(MTB.getPM());
			x.setSingleEbuildPath(MTB.getText());
			x.doEmerge();
		}
	}
}
