/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package gui.views;
public class FileSystemTreePanel extends javax.swing.JPanel implements javax.swing.event.TreeSelectionListener {
	
	
	private javax.swing.JTree tree;
	private fsl.FileSystemModel model;
	private javax.swing.JScrollPane treeScroller;
	private javax.swing.tree.DefaultTreeCellRenderer renderer;
	private java.net.URL pathCustomOpenIcon, pathCustomClosedIcon, pathCustomLeafIcon;
	private javax.swing.Icon customOpenIcon, customClosedIcon, customLeafIcon;
	
	
	public FileSystemTreePanel() {
		this(new fsl.FileSystemModel());
	}
	
	
	public FileSystemTreePanel(String startPath) {
		this(new fsl.FileSystemModel(startPath));
	}
	
	
	public FileSystemTreePanel(fsl.FileSystemModel m) {
		model=m;
		tree = new javax.swing.JTree(m) {
		public String convertValueToText(Object value, boolean selected,
			boolean expanded, boolean leaf, int row,
			boolean hasFocus) {
				return ((java.io.File)value).getName();
			}
		};
		
		
		pathCustomOpenIcon = this.getClass().getClassLoader().getResource("grnball.gif");
		pathCustomClosedIcon = this.getClass().getClassLoader().getResource("redball.gif");
		pathCustomLeafIcon = this.getClass().getClassLoader().getResource("bludiamd.gif");
		customOpenIcon = new javax.swing.ImageIcon(pathCustomOpenIcon);
		customClosedIcon = new javax.swing.ImageIcon(pathCustomClosedIcon);
		customLeafIcon = new javax.swing.ImageIcon(pathCustomLeafIcon);
		
		
		tree.setRootVisible( false );
		tree.setShowsRootHandles( true );
		tree.putClientProperty( "javax.swing.JTree.lineStyle", "Angled" );
		tree.setBackground(new java.awt.Color(0,0,0));
		tree.setFont(new java.awt.Font("Dialog",0,14));
		//tree.getSelectionModel().setSelectionMode(javax.swing.tree.TreeSelectionModel.SINGLE_TREE_SELECTION);
		tree.addTreeSelectionListener(this);
		
		
		renderer = new javax.swing.tree.DefaultTreeCellRenderer();
		renderer.setBackgroundNonSelectionColor(new java.awt.Color(0,0,0));
		renderer.setTextNonSelectionColor(new java.awt.Color(255,255,255));
		renderer.setOpenIcon(customOpenIcon);
		renderer.setClosedIcon(customClosedIcon);
		renderer.setLeafIcon(customLeafIcon);
		tree.setCellRenderer(renderer);
		
		
		treeScroller = new javax.swing.JScrollPane(tree);
		
		
		setLayout( new java.awt.BorderLayout() );
		setPreferredSize(new java.awt.Dimension(350,450));
		add( treeScroller, java.awt.BorderLayout.CENTER );
	}
	
	
	public javax.swing.JTree getTree() {
		return tree;
	}
	
	
	public fsl.FileSystemModel getModel() {
		return model;
	}
	
	
	public void valueChanged(javax.swing.event.TreeSelectionEvent event) {
		try{
		}
		catch (java.lang.NullPointerException e) {
		}
	}
	
	
	public void refreshView() {
		logic.SwingWorker worker = new logic.SwingWorker() {
			public Object construct() {
				return tree;
			}
			public void finished() {
				java.util.Enumeration TreePathsToExpand = tree.getExpandedDescendants(new javax.swing.tree.TreePath(model.getRoot()));
				
				
				javax.swing.event.TreeModelEvent event = new javax.swing.event.TreeModelEvent(this.getClass(),new javax.swing.tree.TreePath(tree.getModel().getRoot()));
				model.fireTreeStructureChanged(event);
				
				
				while(TreePathsToExpand.hasMoreElements()) {
					try {
						javax.swing.tree.TreePath x = ((javax.swing.tree.TreePath)TreePathsToExpand.nextElement());
						tree.expandPath(x);
					}
					catch (java.lang.NullPointerException ex) {
					}
				}
			}
		};
		worker.start();
	}
}
