/*
Copyright (C) 2002 Milos Negovanovic

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




package logic;
public class Ebuild {
	// Referance to the PortageMaster.
	private gui.frames.PortageMaster pm;
	
	
	// XXX why is this here XXX
	private boolean DebugMode = true;
	
	
	// Some Ebuld specific properties.
	private String HomePage;
	private String Description;
	private String License;
	
	
	// Search string that we use when searches for Ebuilds are performed.
	private String searchString;
	
	
	// We can to editing with an external editor, EditString needs to be
	// set to path of the file we want to edit.
	private String EditString;
	
	
	// Ebuild paths in diff formats, and associated helper variables.
	private String[] EbuildPaths;
	private String EbuildPath;
	private java.util.Enumeration TreePaths;
	private java.util.Enumeration TreePathsToUpdate;
	private java.util.Enumeration TreePathsToExpand;
	
	
	// Helper variables.
	private String[] stringarray;
	//private boolean result;
	private boolean wasEmerging = false;
	private boolean wasRsyncing = false;
	
	
	//
	// Constructors.
	//
	public Ebuild() {
	}
	public Ebuild(gui.frames.PortageMaster x) {
		pm = x;
	}
	
	
	//
	// Property manipulators in get/set style.
	//
	public void setTreePaths(java.util.Enumeration e) {
		TreePaths = e;	
	}
	
	
	//search string
	public String getSearchString() {
		return searchString;
	}
	public void setSearchString(String s) {
		searchString = s;
	}
	// Edit string
	public String getEditString() {
		return EditString;
	}
	public void setEditString(String s) {
		EditString = s;
	}
	
	
	public void setEbuildPaths(String[] a) {
		EbuildPaths = a;
	}
	public void setSingleEbuildPath(String s) {
		String[] path = new String[1];
		path[0] = s;
		EbuildPaths = path;
	}
	
	
	public String getHomePage() {
		return HomePage;
	}
	public String getDescription() {
		return Description;
	}
	public String getLicense() {
		return License;
	}
	
	
	//
	// Just a wraper for emergeFromTree() and emergeFew(). To do work we need
	// one of the falowing:
	// 1) TreePaths (Enumeration)
	// 2) EbuldPaths (String)
	//
	// Depending on which one is present doEmerge will activate matching private
	// method.
	//
	public void doEmerge() {
		if (TreePaths != null)
			emergeFromTree();
		else
			emergeFew();
	}
	
	
	//
	// Mergeing through use of 'emerge' command which is executed with help of
	// Runtime.getRuntime().exec(). 
	// Its used from the JTree mainly (needs TreePaths to do the work). Why did
	// we do it this way? Well it makes all updates on the JTree view of portage
	// tree, and other parts of the file system, much easier.
	//
	private void emergeFromTree() {
		while (TreePaths.hasMoreElements()) {
			EbuildPath = TreePaths.nextElement().toString();
			SwingWorker worker = new SwingWorker() {
				public Object construct() {
					if (!pm.getStatusPane().getRsyncStatus()) {
						String s = "";
						String n = "";
						try {
							Process p = Runtime.getRuntime().exec("emerge --pretend " + EbuildPath);
							java.io.BufferedReader stdInput = new java.io.BufferedReader(new java.io.InputStreamReader (p.getInputStream()));
							
							
							while ( (s = stdInput.readLine()) != null) {
								if ((s = processInputLine(s)) != null) {
									n = n + s + "\n";
								}
							}
							p.destroy();
							
							
							Object[] options = {"OK","Cancel"};
							int result = javax.swing.JOptionPane.showOptionDialog(null,"\n" + n + "\n\n" +"Proceed?",
								"Question",
								javax.swing.JOptionPane.YES_NO_OPTION,
								javax.swing.JOptionPane.QUESTION_MESSAGE,
								null,
								options,
								options[1]);
							if (result == 0) {
								try {
									wasEmerging = true;
									pm.getStatusPane().setCurrentEmerges(pm.getStatusPane().getCurrentEmerges() + 1);
									pm.getStatusPane().setStatus("Emerging " + pm.getStatusPane().getCurrentEmerges() + " package(s) at the moment ... please wait");
									
									
									String[] cmd = {"/bin/sh", "-c", "/usr/bin/emerge " + EbuildPath + " 2>&1"};
									Process p1 = Runtime.getRuntime().exec(cmd);
									java.io.BufferedReader stdInput1 = new java.io.BufferedReader(new java.io.InputStreamReader (p1.getInputStream()));
									java.io.BufferedReader stdError1 = new java.io.BufferedReader(new java.io.InputStreamReader (p1.getErrorStream()));
									
									
									int index;
									index = pm.getStatusPane().addStatusTab(EbuildPath.substring(EbuildPath.lastIndexOf("/") + 1, EbuildPath.lastIndexOf(".")), p1);
									
									
									pm.getStatusPane().updateStatusTab(" ", index);
									pm.getStatusPane().updateStatusTab(" ", index);
									pm.getStatusPane().updateStatusTab(" ", index);
									while ( (s = stdInput1.readLine()) != null ) {
										pm.getStatusPane().updateStatusTab(s,index);
									}
									
									
									String[] statusTabResult = pm.getStatusPane().removeStatusTab(index);
									gui.dialogs.DialogEmergeResult resultDialog = new gui.dialogs.DialogEmergeResult(pm, EbuildPath, statusTabResult);
									pm.getStatusPane().setCurrentEmerges(pm.getStatusPane().getCurrentEmerges() - 1);
									if (pm.getStatusPane().getCurrentEmerges() == 0) {
										pm.getStatusPane().setStatus(": )");
									}
									else
									{
										pm.getStatusPane().setStatus("Emerging " + pm.getStatusPane().getCurrentEmerges() + " package(s) at the moment ... please wait");
									}
								}
								catch (java.io.IOException e) {
									System.out.println("RunCommand.java exception: ");
									e.printStackTrace();
								}
							}
						}
						catch (java.io.IOException e) {
									System.out.println("RunCommand.java exception: ");
									e.printStackTrace();
						}
					}
					else {
						javax.swing.JOptionPane.showMessageDialog(null, "Rsync is running ... try again after its finished.");
					}
					return EbuildPath;
				}
				public void finished() {
					if (wasEmerging)
						pm.getInstalledPackagesView().refreshView();
				}
			};
			worker.start();
		}
	}
	
	
	//
	// When the ebuild(ebuilds) we work with are avalible to us in a form
	// of a String[] we use emergeFew(). Its not much different from 
	// emergeFromTree() above.
	//
	private void emergeFew() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				if (!pm.getStatusPane().getRsyncStatus()) {
					for (int i = 0;i<EbuildPaths.length;i++) {
						String s = "";
						String n = "";
						try {
							Process p = Runtime.getRuntime().exec("emerge --pretend " + EbuildPaths[i]);
							java.io.BufferedReader stdInput = new java.io.BufferedReader(new java.io.InputStreamReader (p.getInputStream()));
							
							
							while ( (s = stdInput.readLine()) != null) {
								if ((s = processInputLine(s)) != null) {
									n = n + s + "\n";
								}
							}
							p.destroy();
							
							
							Object[] options = {"OK","Cancel"};
							int result = javax.swing.JOptionPane.showOptionDialog(null,"\n" + n + "\n\n" +"Proceed?",
								"Question",
								javax.swing.JOptionPane.YES_NO_OPTION,
								javax.swing.JOptionPane.QUESTION_MESSAGE,
								null,
								options,
								options[1]);
							
							if (result == 0) {
								try {
									pm.getStatusPane().setCurrentEmerges(pm.getStatusPane().getCurrentEmerges() + 1);
									pm.getStatusPane().setStatus("Emerging " + pm.getStatusPane().getCurrentEmerges() + " package(s) at the moment ... please wait");
									
									
									String[] cmd = {"/bin/sh", "-c", "/usr/bin/emerge " + EbuildPaths[i] + " 2>&1"};
									Process p1 = Runtime.getRuntime().exec(cmd);
									
									
									java.io.BufferedReader stdInput1 = new java.io.BufferedReader(new java.io.InputStreamReader (p1.getInputStream()));
									java.io.BufferedReader stdError1 = new java.io.BufferedReader(new java.io.InputStreamReader (p1.getErrorStream()));
									
									
									int index;
									if (EbuildPaths[i].endsWith(".ebuild"))
										index = pm.getStatusPane().addStatusTab(EbuildPaths[i].substring(EbuildPaths[i].lastIndexOf("/") + 1, EbuildPaths[i].lastIndexOf(".")), p1);
									else
										index = pm.getStatusPane().addStatusTab(EbuildPaths[i].substring(EbuildPaths[i].lastIndexOf("/") + 1, EbuildPaths[i].length()), p1);
									
									
									pm.getStatusPane().updateStatusTab(" ", index);
									pm.getStatusPane().updateStatusTab(" ", index);
									pm.getStatusPane().updateStatusTab(" ", index);
									while ( (s = stdInput1.readLine()) != null) {
										pm.getStatusPane().updateStatusTab(s,index);
									}
									
									
									String[] statusTabResult = pm.getStatusPane().removeStatusTab(index);
									gui.dialogs.DialogEmergeResult resultDialog = new gui.dialogs.DialogEmergeResult(pm, EbuildPaths[i], statusTabResult);
									
									
									pm.getInstalledPackagesView().refreshView();
									
									
									pm.getStatusPane().setCurrentEmerges(pm.getStatusPane().getCurrentEmerges() - 1);
									if (pm.getStatusPane().getCurrentEmerges() == 0) {
										pm.getStatusPane().setStatus(": )");
									}
									else
									{
										pm.getStatusPane().setStatus("Emerging " + pm.getStatusPane().getCurrentEmerges() + " package(s) at the moment ... please wait");
									}
								}
								catch (java.io.IOException e) {
								}
							}
						}
						catch (java.io.IOException e) {
									System.out.println("RunCommand.java exception: ");
									e.printStackTrace();
						}
					}
				}
				else {
					javax.swing.JOptionPane.showMessageDialog(null, "Rsync is running ... try again after its finished.");
				}
				return EbuildPath;
			}
			public void finished() {
			}
		};
		worker.start();
	}
	
	
	//
	//unmerge
	//
	public void unmerge(java.util.Enumeration treepaths, java.util.Enumeration toupdate, java.util.Enumeration toexpand) {
		TreePaths = treepaths;
		TreePathsToUpdate = toupdate;
		TreePathsToExpand = toexpand;
		
		
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
					try {
						while(TreePaths.hasMoreElements()) {
							String[] cmd = {"/bin/sh", "-c", "/usr/sbin/ebuild " + TreePaths.nextElement().toString() + " unmerge"};
							Process p = Runtime.getRuntime().exec(cmd);
							java.io.BufferedReader stdInput = new java.io.BufferedReader(new java.io.InputStreamReader (p.getInputStream()));
							while (stdInput.readLine() != null) {
							}
						}
					}
					catch (java.io.IOException e) {
					}
					return EbuildPath;
			}
			public void finished() {
				while(TreePathsToUpdate.hasMoreElements()) {
					javax.swing.tree.TreePath x = (javax.swing.tree.TreePath)TreePathsToUpdate.nextElement();
					javax.swing.event.TreeModelEvent event = new javax.swing.event.TreeModelEvent(this.getClass(),x);
					pm.getInstalledPackagesView().getModel().fireTreeStructureChanged(event);
				}
				while(TreePathsToExpand.hasMoreElements()) {
					try {
						javax.swing.tree.TreePath x = ((javax.swing.tree.TreePath)TreePathsToExpand.nextElement());
						pm.getInstalledPackagesView().getTree().expandPath(x);
					}
					catch (java.lang.NullPointerException ex) {
					}
				}
			}
		};
		worker.start();
	}
	
	
	//
	//updating ebuilds using 'rsync'
	//
	public void rsync() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				String s = new String();
				if(!(pm.getStatusPane().getRsyncStatus())) {
					try {
						
						
						wasRsyncing = true;
						pm.getStatusPane().setRsyncStatus(true);
						int index;
						index = pm.getStatusPane().addStatusTab("Rsync ...");
						
						
						String[] cmd = {"/bin/sh", "-c", "emerge rsync 2>&1"};
						Process p = Runtime.getRuntime().exec(cmd);
						
						
						java.io.BufferedReader stdInput = new java.io.BufferedReader(new java.io.InputStreamReader (p.getInputStream()));
						
						
						while ( (s = stdInput.readLine()) != null) {
							pm.getStatusPane().updateStatusTab(s,index);
						}
						
						
						pm.getStatusPane().removeStatusTab(index);
						javax.swing.JOptionPane.showMessageDialog(null, "Rsync is finished!!!");
					}
					catch (java.io.IOException e) {
						System.out.println("RunCommand.java exception: ");
						e.printStackTrace();
					}
				}
				else {
					javax.swing.JOptionPane.showMessageDialog(null, "Rsync is running ... try again after its finished.");
				}
				return s;
			}
			
			public void finished() {
				if (wasRsyncing) {
					pm.getInstalledPackagesView().refreshView();
					pm.getStatusPane().setRsyncStatus(false);
				}
			}
		};
		worker.start();
	}
	
	
	//
	//update world, actualy just pretended one
	//
	public void updateWorld() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				String s = "";
				int counter = 0;
				stringarray = new String[5000];
				try {
					Helper h = new Helper();
					Process p = Runtime.getRuntime().exec("emerge --pretend --update --deep world");
					java.io.BufferedReader stdInput = new java.io.BufferedReader(new java.io.InputStreamReader (p.getInputStream()));
					
					
					while ( (s = stdInput.readLine()) != null) {
						if ((s = processInputLine(s)) != null) {
							stringarray[counter]=s;
							counter = counter +1;
						}
					}
					p.destroy();
					
					
					stringarray = h.realLength(stringarray);
					new gui.dialogs.DialogCustomTable(pm,stringarray,"world");
				}
				catch (java.io.IOException e) {
					System.out.println("RunCommand.java exception: ");
					e.printStackTrace();
				}
				return s;
			}
		};
		worker.start();
	}
	
	
	//
	//runs "emerge --pretend --update system" and displays results with further options
	//
	public void updateSystem() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				String s = "";
				int counter = 0;
				stringarray = new String[5000];
				try {
					Process p = Runtime.getRuntime().exec("emerge --pretend --update --deep system");
					java.io.BufferedReader stdInput = new java.io.BufferedReader(new java.io.InputStreamReader (p.getInputStream()));
					
					
					while ( (s = stdInput.readLine()) != null) {
						if ((s = processInputLine(s)) != null) {
							stringarray[counter]=s;
							counter = counter +1;
						}
					}
					p.destroy();
					
					
					Helper h = new Helper();
					stringarray = h.realLength(stringarray);
					new gui.dialogs.DialogCustomTable(pm,stringarray,"system");
				}
				catch (java.io.IOException e) {
					System.out.println("RunCommand.java exception: ");
					e.printStackTrace();
				}
				return s;
			}
		};
		worker.start();
	}
	
	
	//
	//runs simple "find /usr/portage -iname xxx" command
	//
	public void find() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				String s = "";
				String n = "";
				int counter = 0;
				stringarray = new String[5000];
				try {
					Process p = Runtime.getRuntime().exec("find /usr/portage -iname *" + searchString + "*");
					java.io.BufferedReader stdInput = new java.io.BufferedReader(new java.io.InputStreamReader (p.getInputStream()));
					while ( (s = stdInput.readLine()) != null) {
						if (s.endsWith(".ebuild")) {
							s=s.substring(12);
							stringarray[counter]=s;
							counter = counter +1;
						}
					}
					Helper h = new Helper();
					stringarray=h.realLength(stringarray);
					new gui.dialogs.DialogCustomTable(pm,stringarray,"find");
				}
				catch (java.io.IOException e) {
					System.out.println("RunCommand.java exception: ");
					e.printStackTrace();
				}
				return s;
			}
		};
		worker.start();
	}
	
	
	//
	//edit selected ebuild
	//
	public void edit() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				try {
					Process p = Runtime.getRuntime().exec(pm.getGP().getEditor() + " " + EditString);
				}
				catch (java.io.IOException e) {
					System.out.println("RunCommand.java exception: ");
					e.printStackTrace();
				}
				return EditString;
			}
		};
		worker.start();
	}
	
	
	//
	// refresh tab in focus
	//
	public void refresh() {
		gui.views.FileSystemTreePanel x = (gui.views.FileSystemTreePanel)pm.getSelectedTab();
		x.refreshView();
	}
	
	
	//
	//parse ebuild file and isolate homepage, license ... 
	//
	public void readEbuildProperties() {
		Helper helper = new Helper();
		
		
		try {
			java.io.BufferedReader reader = new java.io.BufferedReader(new java.io.FileReader(new java.io.File(EbuildPaths[0])));
			
			
			String s;
			while((s = reader.readLine()) != null) {
				if (s.startsWith("DESCRIPTION")==true) {
					Description = helper.cleanUp(s);
				}
				if (s.startsWith("HOMEPAGE")==true) {
					HomePage = helper.cleanUp(s);
				}
				if (s.startsWith("LICENSE")==true) {
					License = helper.cleanUp(s);
				}
			}
		}
		catch (java.io.FileNotFoundException e) {
		}
		catch (java.io.IOException e) {
		}
		EditString = EbuildPaths[0];
	}
	
	
	//
	//run browser command + whatever else we find suitable (homepage)
	//
	public void browse() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				try {
					Process p = Runtime.getRuntime().exec(pm.getGP().getBrowser() + " " + HomePage);
				}
				catch (java.io.IOException e) {
				}
				
				
				return pm;
			}
		};
		worker.start();
	}
	
	
	//
	// view change log in editor of choice
	//
	public void viewChangeLog() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				try {
					Process p = Runtime.getRuntime().exec(pm.getGP().getEditor() + " " + EbuildPaths[0].substring(0, EbuildPaths[0].lastIndexOf("/") + 1) + "ChangeLog");
				}
				catch (java.io.IOException e) {
				}
				
				
				return pm;
			}
		};
		worker.start();
	}
	
	
	//
	//"depended on" check with qpkg
	//
	public void queryDeps() {
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				try {
					String path;
					path = EbuildPaths[0].substring(0, EbuildPaths[0].lastIndexOf("/"));
					path = path.substring(12);
					
					
					Process p = Runtime.getRuntime().exec("qpkg -q -nc " + path);
					java.io.BufferedReader reader = new java.io.BufferedReader(new java.io.InputStreamReader (p.getInputStream()));
					
					String s="";
					String n="";
					while ((s = reader.readLine()) != null) {
						n = n + "\n" + s;
					}
					
					
					Object[] options = {"OK"};
					javax.swing.JOptionPane.showOptionDialog(null,n + "\n\n",
						"Deps",
						javax.swing.JOptionPane.YES_NO_OPTION,
						javax.swing.JOptionPane.INFORMATION_MESSAGE,
						null,
						options,
						options[0]);
				}
				catch (java.io.IOException e) {
				}
				
				
				return pm;
			}
		};
		worker.start();
	}
	
	//
	// Process the output of the various commands. We just pick out the interesting bits.
	// Portage is intended to be used by ppl on the command line, and output format changes
	// over time, so processInputLine needs to be updated whenever that happens.
	//
	private String processInputLine(String s) {
		//System.out.println(s);
		if (s.matches(".*ebuild.*FU.*")) {
			s=(s.substring(s.indexOf("]") + 1)).trim();
			s = "Update(F):   " + s;
			return s;
		}
		if (s.matches(".*ebuild.*UD.*")) {
			s=(s.substring(s.indexOf("]") + 1)).trim();
			s = "Update(D):   " + s;
			return s;
		}
		if (s.matches(".*ebuild.*U-.*")) {
			s=(s.substring(s.indexOf("]") + 1)).trim();
			s = "Update(-):   " + s;
			return s;
		}
		if (s.matches(".*ebuild.*U.*")) {
			s=(s.substring(s.indexOf("]") + 1)).trim();
			s = "Update:   " + s;
			return s;
		}
		if (s.matches(".*ebuild.*N.*")) {
			s=(s.substring(s.indexOf("]") + 1)).trim();
			s = "New:   " + s;
			return s;
		}
		if (s.matches(".*ebuild.*R.*")) {
			s=(s.substring(s.indexOf("]") + 1)).trim();
			s = "Re-emerge:   " + s;
			return s;
		}
		if (s.matches(".*ebuild.*F.*")) {
			s=(s.substring(s.indexOf("]") + 1)).trim();
			s = "New(F):   " + s;
			return s;
		}
		if (s.matches(".*blocks.*B.*")) {
			s=(s.substring(s.indexOf("]") + 1)).trim();
			s = "Blocks:   " + s;
			return s;
		}
		else if (s.startsWith("!!!")) {
			return s;
		}
		else if (s.startsWith("emerge:")) {
			return s;
		}
		return null;
	}
}
